﻿namespace AntiAircraftGun.Entities;
/// <summary>
/// Класс-сущность Зенитная установка
/// </summary>
public class EntityAntiAircraftGun : EntityArmoredCar
{   
    /// <summary>
    /// Дополниетльный цвет 
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Метод передачи дополнительного цвета
    /// </summary>
    /// <param name="color"></param>
    public void setAdditionalColor(Color color)
    {
        AdditionalColor = color;
    }
    /// <summary>
    /// Наличие башни
    /// </summary>
    public bool Tower { get; private set; }
    /// <summary>
    /// Наличие радара
    /// </summary>
    public bool Radar { get; private set; }

    /// <summary>
    /// Инициализация полей объекта-класса зенитной установки
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="tower">Наличие башни</param>
    /// <param name="radar">Наличие радара</param>
    public EntityAntiAircraftGun(int speed, double weight, Color bodyColor, bool radar, bool tower, Color additionalColor) : base(speed, weight, bodyColor)
    {      
        Radar = radar;
        Tower = tower;
        AdditionalColor = additionalColor;
    }
}
