﻿namespace AntiAircraftGun.Entities;
/// <summary>
/// Класс - сущность Бронированная машина
/// </summary>
public class EntityArmoredCar
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет 
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Метод передачи цвета
    /// </summary>
    /// <param name="color"></param>
    public void setBodyColor(Color color)
    {
        BodyColor = color;
    }
    /// <summary>
    /// Перемещение зенитной установки
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Конструктор сущности
    /// </summary>
    /// <param name="speed"></param>
    /// <param name="weight"></param>
    /// <param name="bodyColor"></param>
    public EntityArmoredCar(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
    }
}
